"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Action = exports.extractDynamicIdentifier = void 0;
const policy_1 = require("../interfaces/policy");
const constants_1 = require("./constants");
const helper_1 = require("./helper");
exports.extractDynamicIdentifier = helper_1.dynamicIdentifierExtractor(constants_1.ACTION_META_FIELD);
function Action(action) {
    return (target, key, descriptor) => {
        if (!action) {
            let service = target.constructor.name;
            if (constants_1.CTRL_SERVICE_REGEXP.test(service)) {
                service = service.replace(constants_1.CTRL_SERVICE_REGEXP, '');
            }
            action = `${service.toLowerCase()}${policy_1.DELIMITER}${String(key)}`;
        }
        Reflect.defineMetadata(constants_1.ACTION_META_FIELD, action, descriptor.value);
        return descriptor;
    };
}
exports.Action = Action;
