"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MissingPolicyProps = void 0;
const iacry_error_1 = require("./iacry.error");
const policy_1 = require("../interfaces/policy");
class MissingPolicyProps extends iacry_error_1.BaseError {
    constructor(policy, ...props) {
        super(`Missing required properties >> ${props.join(', ')}\nFrom: ${JSON.stringify(policy)}`);
    }
    static assert(policy) {
        const missingProps = [];
        for (const prop of policy_1.REQUIRED_PROPS) {
            if (!policy.hasOwnProperty(prop)) {
                missingProps.push(prop);
            }
        }
        if (missingProps.length > 0) {
            throw new this(policy, missingProps);
        }
    }
}
exports.MissingPolicyProps = MissingPolicyProps;
