import { Action, Resource, Principal, ActionObject, ResourceObject, PrincipalObject } from './interfaces/policy';
import { MatcherResult } from './interfaces/matcher-result';
import { Matcher as MatcherInterface } from './interfaces/matcher';
import { PolicyStorage } from './interfaces/policy-storage';
import { CoreHelper } from './helpers/core';
export declare class Firewall extends CoreHelper {
    readonly storage: PolicyStorage;
    readonly matcher: MatcherInterface;
    constructor(storage: PolicyStorage, matcher: MatcherInterface);
    static create(storage?: PolicyStorage, matcher?: MatcherInterface): Firewall;
    isAllowed(rawResource: Resource | ResourceObject, rawAction: Action | ActionObject, rawPrincipal: Principal | PrincipalObject): Promise<boolean>;
    isAllowedAny(rawResource: Resource | ResourceObject, rawAction: Action | ActionObject, rawPrincipal: Principal | PrincipalObject): Promise<boolean>;
    isAllowedImplicit(rawResource: Resource | ResourceObject, rawAction: Action | ActionObject, rawPrincipal: Principal | PrincipalObject): Promise<boolean>;
    protected resolve(rawResource: Resource | ResourceObject, rawAction: Action | ActionObject, rawPrincipal: Principal | PrincipalObject): Promise<MatcherResult>;
}
