"use strict";
var CoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreModule = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const iacry_service_1 = require("./iacry.service");
const constants_1 = require("./constants");
let CoreModule = CoreModule_1 = class CoreModule {
    static forRoot(options) {
        const OptionsProvider = {
            provide: constants_1.IACRY_OPTIONS,
            useValue: options,
        };
        return {
            module: CoreModule_1,
            providers: [OptionsProvider, iacry_service_1.CoreService],
            exports: [iacry_service_1.CoreService],
        };
    }
    static forRootAsync(options) {
        const providers = this.createAsyncProviders(options);
        return {
            module: CoreModule_1,
            providers: [...providers, iacry_service_1.CoreService],
            imports: options.imports,
            exports: [iacry_service_1.CoreService],
        };
    }
    static createAsyncProviders(options) {
        const providers = [this.createAsyncOptionsProvider(options)];
        if (options.useClass) {
            providers.push({
                provide: options.useClass,
                useClass: options.useClass,
            });
        }
        return providers;
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                name: constants_1.IACRY_OPTIONS,
                provide: constants_1.IACRY_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        return {
            name: constants_1.IACRY_OPTIONS,
            provide: constants_1.IACRY_OPTIONS,
            useFactory: (optionsFactory) => tslib_1.__awaiter(this, void 0, void 0, function* () {
                return optionsFactory.createOptions();
            }),
            inject: [options.useExisting || options.useClass],
        };
    }
};
CoreModule = CoreModule_1 = tslib_1.__decorate([
    common_1.Global(),
    common_1.Module({})
], CoreModule);
exports.CoreModule = CoreModule;
