export declare const SID = "Sid";
export declare const ACTION = "Action";
export declare const EFFECT = "Effect";
export declare const RESOURCE = "Resource";
export declare const PRINCIPAL = "Principal";
export declare const ENTITY_FIELD = "entity";
export declare const ID_FIELD = "id";
export declare const DYNAMIC_IDENTIFIER_PROPS: string[];
export declare const DYNAMIC_IDENTIFIER_PROPS_MAPPING: {
    Action: string[];
    Resource: string[];
    Principal: string[];
};
export declare const REQUIRED_PROPS: string[];
export declare const DELIMITER = ":";
export declare const NEGATION = "!";
export declare const OR = "|";
export declare enum Effect {
    ALLOW = "Allow",
    DENY = "Deny"
}
export declare type ANY = '*';
export interface ActionObject {
    readonly service: string | ANY;
    readonly action: string | ANY;
}
export declare type Action = string | ActionObject;
export interface ResourceObject {
    readonly entity: string | ANY;
    readonly id: number | string | ANY;
}
export declare type Resource = string | ResourceObject;
export interface PrincipalObject {
    readonly entity: string | ANY;
    readonly id: number | string | ANY;
}
export declare type Principal = string | PrincipalObject;
export declare type DynamicIdentifierItem<T> = {
    value: T;
    parse(thing: T): Array<string | ANY>;
};
export declare type DynamicIdentifier<T> = T | DynamicIdentifierItem<T>;
export declare type DynamicIdentifierVector<T> = Array<DynamicIdentifier<T>>;
export interface PolicyInterface {
    Sid?: string;
    Effect: Effect;
    Action: DynamicIdentifier<Action> | DynamicIdentifierVector<Action>;
    Resource?: DynamicIdentifier<Resource> | DynamicIdentifierVector<Resource>;
    Principal?: DynamicIdentifier<Principal> | DynamicIdentifierVector<Principal>;
}
