import { Action, Resource, Principal, ActionObject, ResourceObject, PrincipalObject } from './interfaces/policy';
import { MatcherResult } from './interfaces/matcher-result';
import { PolicyVector } from './policy-vector';
import { Matcher as MatcherInterface } from './interfaces/matcher';
import { CoreHelper } from './helpers/core';
export declare class Matcher extends CoreHelper implements MatcherInterface {
    readonly strict: boolean;
    readonly NEGATION_REGEXP: RegExp;
    constructor(strict?: boolean);
    match(rawResource: Resource | ResourceObject, rawAction: Action | ActionObject, rawPrincipal: Principal | PrincipalObject, policies: PolicyVector): MatcherResult;
    private matchDynamicIdentifierVector;
    private matchDynamicIdentifier;
    private matchItem;
    private matchSingle;
    private normalize;
    private extractNegated;
    private isNegated;
}
