"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PolicyVector = void 0;
const policy_1 = require("./policy");
class PolicyVector extends Array {
    constructor(policies) {
        super();
        Object.setPrototypeOf(this, Array.prototype);
        Object.defineProperty(this, 'toJSON', {
            value: PolicyVector.prototype.toJSON.bind(this),
            writable: false,
        });
        this.push(...policies);
    }
    toJSON() {
        return this.map((policy) => policy.toJSON());
    }
    static create(...rawPolicies) {
        const policies = [];
        for (const rawPolicy of rawPolicies) {
            if (rawPolicy instanceof policy_1.Policy) {
                policies.push(rawPolicy);
            }
            else {
                policies.push(new policy_1.Policy(rawPolicy));
            }
        }
        return new this(policies);
    }
}
exports.PolicyVector = PolicyVector;
