import { PolicyInterface, Effect, Action, Resource, Principal, ActionObject, ResourceObject, PrincipalObject, DynamicIdentifier, DynamicIdentifierVector } from './interfaces/policy';
import { CoreHelper } from './helpers/core';
export declare class Policy extends CoreHelper implements PolicyInterface {
    readonly Sid: string;
    readonly Effect: Effect;
    readonly Action: DynamicIdentifier<Action> | DynamicIdentifierVector<Action>;
    readonly Resource: DynamicIdentifier<Resource> | DynamicIdentifierVector<Resource>;
    readonly Principal: DynamicIdentifier<Principal> | DynamicIdentifierVector<Principal>;
    constructor(rawPolicy: string | PolicyInterface);
    property(prop: string): string | Effect | Array<ActionObject | ResourceObject | PrincipalObject>;
    toJSON(parse?: boolean): PolicyInterface;
    protected unpackPolicyDynamicIdentifiers(rawPolicy: PolicyInterface): void;
    protected removePolicyDynamicIdentifiers(rawPolicy: PolicyInterface): void;
    protected normalizePolicyDynamicIdentifiers(rawPolicy: PolicyInterface): void;
}
