"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IoRedis = void 0;
const tslib_1 = require("tslib");
class IoRedis {
    constructor(client) {
        this.client = client;
        this.SUCCESS = 'OK';
        this.EXPIRE = 'EX';
    }
    set(key, value, expire) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            if (!expire) {
                return (yield this.client.set(key, value)) === this.SUCCESS;
            }
            return ((yield this.client.set(key, value, this.EXPIRE, expire)) === this.SUCCESS);
        });
    }
    has(key) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return (yield this.client.exists(key)) === 1;
        });
    }
    get(key) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return this.client.get(key);
        });
    }
    remove(key) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return (yield this.client.del(key)) === 1;
        });
    }
}
exports.IoRedis = IoRedis;
