import { PrincipalObject } from '../interfaces/policy';
import { PolicyStorage } from '../interfaces/policy-storage';
import { PolicyInterface } from '../interfaces/policy';
import { Cache } from './cache/cache.interface';
export interface CachedStorageOptions {
    expire?: number;
    prefix?: string;
}
export declare class CachedStorage implements PolicyStorage {
    readonly storage: PolicyStorage;
    readonly cache: Cache;
    options?: CachedStorageOptions;
    readonly readonly: boolean;
    readonly DEFAULT_OPTIONS: CachedStorageOptions;
    constructor(storage: PolicyStorage, cache: Cache, options?: CachedStorageOptions);
    fetch(principal: PrincipalObject): Promise<Array<string | PolicyInterface>>;
    save(principal: PrincipalObject, rawPolicies: Array<string | PolicyInterface>): Promise<number>;
    add(principal: PrincipalObject, rawPolicies: Array<string | PolicyInterface>): Promise<number>;
    purge(principal: PrincipalObject): Promise<number>;
    private purgeCache;
    private encode;
    private decode;
    private key;
}
