"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HardcodedMemoryStorage = void 0;
const tslib_1 = require("tslib");
const iacry_error_1 = require("../errors/iacry.error");
class HardcodedMemoryStorage {
    constructor(policies = []) {
        this.policies = policies;
        this.readonly = true;
    }
    fetch(_principal) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return this.policies;
        });
    }
    save(_principal, _rawPolicies) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return this.disallowedException('save');
        });
    }
    add(_principal, _rawPolicies) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return this.disallowedException('add');
        });
    }
    purge(_principal) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return this.disallowedException('purge');
        });
    }
    disallowedException(method) {
        throw new iacry_error_1.BaseError(` PolicyInterface Storage method ${method}() invocation not allowed`);
    }
}
exports.HardcodedMemoryStorage = HardcodedMemoryStorage;
