"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MemoryStorage = void 0;
const tslib_1 = require("tslib");
class MemoryStorage {
    constructor(policies = []) {
        this.policies = policies;
        this.readonly = false;
    }
    fetch(_principal) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return this.policies;
        });
    }
    save(_principal, rawPolicies) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            this.policies = rawPolicies;
            return rawPolicies.length;
        });
    }
    add(_principal, rawPolicies) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            this.policies.concat(rawPolicies);
            return rawPolicies.length;
        });
    }
    purge(_principal) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const length = this.policies.length;
            this.policies = [];
            return length;
        });
    }
}
exports.MemoryStorage = MemoryStorage;
