import { PrincipalObject } from '../interfaces/policy';
import { PolicyStorage } from '../interfaces/policy-storage';
import { PolicyInterface } from '../interfaces/policy';
import { Storage } from './sequelize/storage.interface';
export declare class SequelizeStorage implements PolicyStorage {
    private readonly storageRepository;
    readonly readonly: boolean;
    constructor(storageRepository: Storage | any);
    fetch(principal: PrincipalObject): Promise<Array<string | PolicyInterface>>;
    save(principal: PrincipalObject, rawPolicies: Array<string | PolicyInterface>): Promise<number>;
    add(principal: PrincipalObject, rawPolicies: Array<string | PolicyInterface>): Promise<number>;
    purge(principal: PrincipalObject): Promise<number>;
    get repository(): Storage;
    protected isStorageModel(x: any): x is Storage;
}
