import { Model } from 'sequelize-typescript';
import { PrincipalObject, PolicyInterface } from '../../interfaces/policy';
export declare class PoliciesStorage<T> extends Model<PoliciesStorage<T>> implements PrincipalObject {
    pk: number;
    id: string;
    entity: string;
    policy: string;
    createdAt: Date;
    updatedAt: Date;
    deletedAt: Date;
    static savePrincipalPolicies(principal: PrincipalObject, rawPolicies: Array<string | PolicyInterface>, attach?: boolean): Promise<number>;
    static destroyByPrincipal(principal: PrincipalObject): Promise<number>;
    static findByPrincipal(principal: PrincipalObject): Promise<Array<string>>;
    static normalizePolicyItem(item: string): string;
}
